function build_peak_matrix(code,lead_number,peak_size,delays_number)

%This program builds a matrix for batch training--------------------------------------------------------------
Type = 'Low';
st = 71;
fin = 126;
PosNeg = 'P';
%----------------------------------------------------------
if (strcmp(code,'Controls') == 1)
    yy = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19};
elseif (strcmp(code,'OCD') == 1)
    yy = {1,2,3,4,5,6,10,11,12,13,14,15,16,17,18};
else
    error('No such category');
end
%----------------------------------------------
if MOD(peak_size,2)==0
    error('peak_size must be an odd number')
end
if peak_size<delays_number+2
    error('peak_size<delays_number+2')
end

clc;
%manipulate strings and opening the appropriate *.mat file-------
S1 = ['C:\Matlab\work\' Type '\' code];
cd (S1);
S2 = [code '_data'];
load(S2);
SX = ['C:\Matlab\work\' Type '\' code '\NN-peak'];
try
    cd (SX);
catch
    mkdir(S1,'NN-peak');
    cd (SX);
end
%----------------------------------------------------------------

%convert delays_number to string----------
str = int2str(peak_size);
%-----------------------------------------
%convert electrode number to string--    
str2 = int2str(lead_number);
lead_number = lead_number - 1;
%------------------------------------
%convert delays number to string
strd = int2str(delays_number);
%-------------------------------
%name of file in which net is to be saved and loaded--------
sav = ['lead' str2 '-delays' strd];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' code '\NN-peak\' sav];
%-----------------------------------------------------------
%make appropriate directory if it doesn't exist--------------------
temp = exist (sav);
if temp == 0
    mkdir(SX, sav);
end
cd (S2);
clear temp;
%-------------------------------------------------------------------

%keep in memory, only the data for the appropriate node-------------
tem = length(yy);
for i=1:tem
    temk(i) = yy{i};
end;
sizstr = int2str(tem);
NAMP(:,:) = AMP(lead_number,1:512,temk);
clear AMP temk;
%-------------------------------------------------------------------

%find the peaks-----------------------------------------------------
for i=1:tem
    if PosNeg == 'P'
        [M,pn]=max(NAMP(st:fin,i));
    else
        [M,pn]=min(NAMP(st:fin,i));
    end
    pn = pn + st-1;
    AmpP(1:peak_size,i) = NAMP(pn-(peak_size-1)/2:pn+(peak_size-1)/2,i);
    %----------------------------------------------------------------------
    px(i) = (pn-1)*2;
    %----------------------------------------------------------------------
    for j=0:peak_size-1
        AmpDLat(j+1,i) = NAMP(pn+j-(peak_size-1)/2,i)/(px(i)+j-(peak_size-1)/2);
    end
end
%--------------------------------------------------------------------

%build the appropriate filenames-------------------------------------------------------------------------------------
xst = (st-1)*2;
xfin = (fin-1)*2;
if xst==20 & xfin==80
    typestr = 'P50';
elseif xst==76 & xfin==160
    typestr = 'N100';
elseif xst==140 & xfin==250
    typestr = 'P200';
elseif xst==180 & xfin==300
    typestr = 'N200';
elseif xst==220 & xfin==380
    typestr = 'P300';
elseif xst==240 & xfin==500
    typestr = 'P300b';
elseif xst==340 & xfin==500
    typestr = 'N400';
elseif xst==500 & xfin==800
    typestr = 'P600';
else
    typestr = [PosNeg '(' xst '-' xfin ')'];
end
dirstring = [typestr '_peaksize-' str];
%-------------------------------------------------------------------------

Sf = ['C:\Matlab\work\' Type '\' code '\NN-peak\' sav '\' dirstring];
try
    cd(Sf);
catch
    mkdir(S2,dirstring);
    cd(Sf);
end
clear AMP ADL;
%disp('File saved in: ' Sf);
%build the appropriate train matrix which has (peak_size-delays_number-1)*siz columns and  (delays_number+2) lines---------
tempcol = peak_size-delays_number-1;
col = 0;
lin = delays_number + 2;
for k=1:tem
    clc;
    kstr = int2str(k);
    tstr = ['Processing subject ' code ' ' kstr ' of ' sizstr];
    disp(tstr);
    prAMP = AmpP;
    prADL = AmpDLat;
    for j=1:tempcol
        col = col + 1;
        AMP(1:lin,col) = AmpP(j:(j+lin-1),k);
        ADL(1:lin,col) = AmpDLat(j:(j+lin-1),k);
    end
end
clear NAMP AmpP AmpDLat k j S2 tempcol kstr tstr sizstr;
%end build matrix-----------------------------------------------------------------------------------------------------------
%preprocessing the matrix------------------------------------------------------------
AMP = transpose(AMP);
minAMP(1:col) = min(min(AMP));
maxAMP(1:col) = max(max(AMP));
maxAMP = maxAMP';
minAMP = minAMP';
AMP = tramnmx(AMP,minAMP,maxAMP);
AMP = transpose(AMP);
minAMP = minAMP(1);
maxAMP = maxAMP(1);
%------------------------------------------------------------------------------------
%preprocessing the matrix------------------------------------------------------------
ADL = transpose(ADL);
minADL(1:col) = min(min(ADL));
maxADL(1:col) = max(max(ADL));
maxADL = maxADL';
minADL = minADL';
ADL = tramnmx(ADL,minADL,maxADL);
ADL = transpose(ADL);
minADL = minADL(1);
maxADL = maxADL(1);
num = length(yy);
%------------------------------------------------------------------------------------
save ('matrices','ADL','minADL','maxADL','AMP','minAMP','maxAMP','px','num','prAMP','prADL');
%-------------------------------------------