function peak_train(code,lead_number,peak_size,delays_number)
%-------------------------------------------------------------------------------------------------------------
%This program trains a network to simulate the Amplitudes of a subject category-------------------------------
%how many instances of the signal to be used---
Type = 'Low';
catstr = 'P200'
st = 71;
fin = 126;
hid1 = 15;
hid2 = 15;
hid3 = 10;
%----------------------------------------------
clc;
global cnt
%----------------------------------------------
subcol = peak_size - delays_number - 1;
%convert delays_number to string---------
str = int2str(delays_number);
%----------------------------------------
pkstr = int2str(peak_size);
%convert electrode number to string--
str2 = int2str(lead_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = ['lead' str2 '-delays' str '\' catstr '_peaksize-' pkstr];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' code '\NN-peak\' sav];
%-----------------------------------------------------------
%load the appropriate matrix or return error-------------------------------------------
try
    cd(S2);
    ststr = int2str(st);
    finstr = int2str(fin);
    temp = [S2 '\matrices'];
    load (temp);
    MATRIX = AMP; %-------------------------------<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    minM = minAMP;
    maxM = maxAMP;
    %----------------------------------------------------------
    if (isempty(cnt)==1)
        clear global cnt;
        cnt = 0;
        while (cnt < 1) | (cnt > num)
            numstr = int2str(num);
            tmp = ['Leave out which subject? (1-' numstr '):   '];
            cnt = input(tmp);
        end
    end
    clear tmp numstr;
    %-----------------------------------------------------------
    col = size(MATRIX,2);
    lin = size(MATRIX,1);
    if (cnt > 1 & cnt < num)
        TEMP(:,1:(cnt-1)*subcol) = MATRIX(:,1:(cnt-1)*subcol);
        TEMP(:,((cnt-1)*subcol+1):(col-subcol)) = MATRIX(:,(cnt*subcol+1):col);
    elseif (cnt == 1)
        TEMP = MATRIX(:,(subcol+1):col);
    else
        TEMP = MATRIX(:,1:((cnt-1)*subcol));
    end
    clear MATRIX;
    col = size(TEMP,2);     %length of matrix
    colpsub = col/(num-1);      %rows per subjects
    trainsize = col-colpsub*4;
    validsize = colpsub*4;
    %randomizing the columns of MATRIX---------------------------------------------------
    perm = randperm(trainsize);
    for i=1:trainsize
        MATRIX(:,perm(i)) = TEMP(:,i);
    end
    %------------------------------------------------------------------------------------
    for i=1:validsize
        VALID(:,i) = TEMP(:,trainsize+i);
    end
    clear TEMP temp perm;
catch
    disp('Error in loading data matrix for batch training');
    error('Execute function build_peak_matrix with the appropriate parameters');
end
%--------------------------------------------------------------------------------------

%training the network-----------------------------------------
p{1} = MATRIX(lin-1,:);
t{1} = MATRIX(lin,:);
for i=1:(lin-2)
    Pi{i}=MATRIX(i,:);
end
clear MATRIX;
VV.P{1} = VALID(lin-1,:);
VV.T{1} = VALID(lin,:);
for i=1:(lin-2)
    VV.Pi{i}=VALID(i,:);
end

disp('Network building and training');
disp('----------------------------------------------------------------------------------------------------------------------------');
%defining the network----------------------
cntstr = int2str(cnt);
str = ['peak_net(' ststr '-' finstr ')ex' cntstr '.mat'];
strpic = ['train_perf(' ststr '-' finstr ')ex' cntstr];
strx2 = [S2 '\' str];
temp = exist (strx2);
if temp ~= 0
    load (str);
    net.trainParam.minstep = 1e-08;
    net.trainParam.goal = 0;
    net.trainParam.epochs = 2;
    epotmp = epo;
else
    if hid3 == 0
        net = newfftd([-1 1],[0:1:delays_number],[hid1 hid2 1],{'tansig' 'tansig' 'purelin'},'trainlm');
    else
        net = newfftd([-1 1],[0:1:delays_number],[hid1 hid2 hid3 1],{'tansig' 'tansig' 'tansig' 'purelin'},'trainlm');
    end
    net.trainParam.goal = 0;
    net.trainParam.mem_reduc = 1;
    net.trainParam.lr = 0.1;
    net.trainParam.epochs = 20;
    net.trainParam.show = 1;
    net.trainParam.minstep = 1e-20;
    epotmp = 0;
end
clear temp;
%------------------------------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
if hid3 == 0
    newtmpstr = [strhid1 '-' strhid2 '('ststr '-' finstr ')'];
else
    strhid3 = int2str(hid3);
    newtmpstr = [strhid1 '-' strhid2 '-' strhid3 '('ststr '-' finstr ')'];
end
try
    cd (newtmpstr);
catch
    mkdir(S2,newtmpstr);
    cd (newtmpstr);
end
    [net,tr] = train(net,p,t,Pi,[],VV);
    epo = tr.epoch(end) + epotmp;
    perf = tr.perf(end);
    save (str,'net','maxM','minM','epo','perf','pn');
    print('-dbmp', '-r80', strpic);
%    dos ('C:\Progra~1\winamp\winamp.exe/ E:\Songs\Napster_Songs\test.M3U');
%    dos ('C:\Progra~1\12Ghosts\12Shut~1.exe');
%------------------------------------------
%--------------------------------------------------------------